var ENTER_KEYCODE = 13;
var _path = '/';
var _pendingReloads = [];
var _reloadingDisabled = 0;
var document_h = 0;
var divcount = 0;

//格式化文件大小
function formatFileSize(bytes) {
  if (bytes >= 1000000000) {
    return (bytes / 1000000000).toFixed(2) + ' GB';
  }
  if (bytes >= 1000000) {
    return (bytes / 1000000).toFixed(2) + ' MB';
  }
  return (bytes / 1000).toFixed(2) + ' KB';
}

function _showError(message, textStatus, errorThrown) {
  $("#alerts").prepend(tmpl("template-alert", {
    level: "danger",
    title: (errorThrown != "" ? errorThrown : textStatus) + ": ",
    description: message
  }));
}

function _disableReloads() {
  _reloadingDisabled += 1;
}

function _enableReloads() {
  _reloadingDisabled -= 1;
  
  if (_pendingReloads.length > 0) {
    _reload(_pendingReloads.shift());
  }
}
//重新加载页面
function _reload(path) {
  if (_reloadingDisabled) {
    if ($.inArray(path, _pendingReloads) < 0) {
      _pendingReloads.push(path);
    }
    return;
  }
  
  _disableReloads();
  var dTime=new Date();
  $.ajax({
    url: 'list',
    type: 'GET',
    data: {path: path, t:dTime.getTime()},
    dataType: 'json'
  }).fail(function(jqXHR, textStatus, errorThrown) {
    _showError("Failed retrieving contents of \"" + path + "\"", textStatus, errorThrown);
  }).done(function(data, textStatus, jqXHR) {
    var scrollPosition = $(document).scrollTop();
    
    if (path != _path) {
      $("#path").empty();
      /*if (path == "/") {
        $("#path").append('<li class="active">' + _device + '</li>');
      } else {*/
        //$("#path").append('<li data-path="/"><a>' + _device + '</a></li>');
        var components = path.split("/").slice(1, -1);
        for (var i = 0; i < components.length - 1; ++i) {
          var subpath = "/" + components.slice(0, i + 1).join("/") + "/";
          $("#path").append('<li data-path="' + subpath + '"><a>' + components[i] + '</a></li>');
        }
        $("#path > li").click(function(event) {
          _reload($(this).data("path"));
          event.preventDefault();
        });
        $("#path").append('<li class="active">' + components[components.length - 1] + '</li>');
      }
        //$("#path").attr("path",path);
      _path = path;
    /*}*/
    
    $("#listing").empty();
    for (var i = 0, file; file = data[i]; ++i) {
      $(tmpl("template-listing", file)).data(file).appendTo("#listing");
    }
    $(".pic,.shade").css("height",$(".pic,.shade").width());
    document_h = $(document).height();
    //divcount = $(".album").length + $(".photo").length;
    divcount = data.length;
    //if(divcount > 5){
    //  $(".content").height(document_h - 350);
    //}else {
    //  $(".content").height(500);
    //}


    //返回按钮
    $(".header-title > img").on('click',function(event) {
      prevpath = $("#path li[class='active']").prev().data("path");
      if(typeof(prevpath)=="undefined"){
        prevpath = "/photo/";
      }
      _reload(prevpath);
      event.preventDefault();
    });


    //编辑文件夹或文件
    $(".edit").editable(function(value, settings) {
        console.log('newname = '+value);
      var name = $(this).closest(".edit").data("name");
        console.log('oldname = '+name);
      if (value != name) {
        var path = $(this).closest(".listb").data("path");
        var id = $(this).closest(".listb").data("id");
          console.log('oldpath = '+path);
          console.log('newpath = '+_path+value);
        $.ajax({
          url: 'move',
          type: 'POST',
          data: {id: id,oldPath: path, newPath: _path + value},
          dataType: 'json'
        }).fail(function(jqXHR, textStatus, errorThrown) {
          _showError("Failed moving \"" + path + "\" to \"" + _path + value + "\"", textStatus, errorThrown);
        }).always(function() {
          _reload(_path);
        });
      }
      return value;
    }, {
      onedit: function(settings, original) {
        _disableReloads();
      },
      onsubmit: function(settings, original) {
        _enableReloads();
      },
      onreset: function(settings, original) {
        _enableReloads();
      },
      tooltip: '点击重命名'
    });

    //下载文件
    $(".button-download").click(function(event) {
      var path = $(this).closest(".listb").data("path");
      setTimeout(function() {
        window.location = "download?path=" + encodeURIComponent(path);
      }, 0);
    });

    //打开文件夹
    $(".button-open").click(function(event) {
        //$("#create-folder").hide();
      var path = $(this).closest(".listb").data("path");
      _reload(path);
    });

    //重命名
    $(".button-move").click(function(event) {
      var path = $(this).parent().parent().data("path");
      if (path[path.length - 1] == "/") {
        path = path.slice(0, path.length - 1);
      }
      $("#move-input").data("path", path);
      $("#move-input").val(path);
      $("#move-modal").modal("show");
    });

    //删除文件或文件夹
    $(".button-delete").click(function(event) {
      var path = $(this).closest(".listb").data("path");
      var id = $(this).closest(".listb").data("id");
      $.ajax({
        url: 'delete',
        type: 'POST',
        data: {id:id,path: path},
        dataType: 'json'
      }).fail(function(jqXHR, textStatus, errorThrown) {
        _showError("删除失败 \"" + path + "\"", textStatus, errorThrown);
      }).always(function() {
        _reload(_path);
      });
    });
    
    $(document).scrollTop(scrollPosition);
  }).always(function() {
    _enableReloads();
  });
}

//页面加载完成后执行
$(function(){

  //上传文件
  // Workaround Firefox and IE not showing file selection dialog when clicking on "upload-file" <button>
  // Making it a <div> instead also works but then it the button doesn't work anymore with tab selection or accessibility
  $("#upload-file").click(function(event) {
    $("#fileupload").click();
  });
  
  // Prevent event bubbling when using workaround above
  $("#fileupload").click(function(event) {
    event.stopPropagation();
  });
  
  $("#fileupload").fileupload({
    dropZone: $(document),
    pasteZone: null,
    autoUpload: true,
    sequentialUploads: true,
    // limitConcurrentUploads: 2,
    // forceIframeTransport: true,
    
    url: 'upload',
    type: 'POST',
    dataType: 'json',
    
    start: function(e) {
      $(".uploading").show();
    },
    
    stop: function(e) {
      $(".uploading").hide();
    },
    
    add: function(e, data) {
      var file = data.files[0];
      data.formData = {
        path: _path
      };
      data.context = $(tmpl("template-uploads", {
        path: _path + file.name
      })).appendTo("#uploads");
      var jqXHR = data.submit();
      data.context.find("button").click(function(event) {
        jqXHR.abort();
      });
    },
    
    progress: function(e, data) {
      var progress = parseInt(data.loaded / data.total * 100, 10);
      data.context.find(".progress-bar").css("width", progress + "%");
    },
    
    done: function(e, data) {
      _reload(_path);
    },
    
    fail: function(e, data) {
      var file = data.files[0];
      if (data.errorThrown != "abort") {
        _showError("Failed uploading \"" + file.name + "\" to \"" + _path + "\"", data.textStatus, data.errorThrown);
      }
    },
    
    always: function(e, data) {
      data.context.remove();
    }
    
  });
  
  $("#create-input").keypress(function(event) {
    if (event.keyCode == ENTER_KEYCODE) {
      $("#create-confirm").click();
    }
  });
  
  $("#create-modal").on("shown.bs.modal", function(event) {
    $("#create-input").focus();
    $("#create-input").select();
  });
  
  $("#create-folder").click(function(event) {
    $("#create-input").val("未命名文件夹");
    $("#create-modal").modal("show");
  });
  
  $("#create-confirm").click(function(event) {
    $("#create-modal").modal("hide");
    var name = $("#create-input").val();
    if (name != "") {
      $.ajax({
        url: 'create',
        type: 'POST',
        data: {path: _path + name},
        dataType: 'json'
      }).fail(function(jqXHR, textStatus, errorThrown) {
        _showError("Failed creating folder \"" + name + "\" in \"" + _path + "\"", textStatus, errorThrown);
      }).always(function() {
        _reload(_path);
      });
    }
  });
  
  $("#move-input").keypress(function(event) {
    if (event.keyCode == ENTER_KEYCODE) {
      $("#move-confirm").click();
    }
  });
  
  $("#move-modal").on("shown.bs.modal", function(event) {
    $("#move-input").focus();
    $("#move-input").select();
  });
  
  $("#move-confirm").click(function(event) {
    $("#move-modal").modal("hide");
    var oldPath = $("#move-input").data("path");
    var newPath = $("#move-input").val();
    if ((newPath != "") && (newPath[0] == "/") && (newPath != oldPath)) {
      $.ajax({
        url: 'move',
        type: 'POST',
        data: {oldPath: oldPath, newPath: newPath},
        dataType: 'json'
      }).fail(function(jqXHR, textStatus, errorThrown) {
        _showError("Failed moving \"" + oldPath + "\" to \"" + newPath + "\"", textStatus, errorThrown);
      }).always(function() {
        _reload(_path);
      });
    }
  });
  
  $("#reload").click(function(event) {
    _reload(_path);
  });

    function init_folder(){
        var newarr = new Array('download','video','txt','kanfile','other');
		var dTime=new Date();
        $.ajax({
            url: 'list',
            type: 'GET',
            data: {path: '/0.kan.bar/', t:dTime.getTime()},
            dataType: 'json'
        }).done(function(data, textStatus, jqXHR) {
            var folderarr = new Array();
            for (var i = 0, file; file = data[i]; ++i) {
                folderarr[i] = file['name'];
                //$(tmpl("template-listing", file)).data(file).appendTo("#listing");
            }
            for(var j = 0; j < 5; j++){
                if($.inArray(newarr[j],folderarr) < 0){
                    $.ajax({
                        url: 'create',
                        type: 'POST',
                        data: {path: '/0.kan.bar/' + newarr[j]},
                        dataType: 'json'
                    });
                }
            }
            //初始化照片目录下内容
            _reload('/0.kan.bar/');
        });
    }

    //初始化文件目录
    init_folder();

});
